<template>
  <div>
    <v-row justify="space-between">
      <v-col cols="12" md="auto">
        <p class="text-h5 primary-color page-title">
          Información de la compañía
        </p>
      </v-col>
    </v-row>
    <v-card class="mx-auto provider-company-card" max-width="100%">
      <v-card-subtitle class="pb-0">
        <image-field :value="providerCompany.imageUrl" :disabled="disabled_user_info" :validation="imageValidation" />
        <v-divider />
        <v-form ref="form" lazy-validation>
          <v-container fluid>
            <register-field-validation
              :value="providerCompany.ruc"
              :disabled="disabled_user_info"
              field-name="RUC"
              :validation="rucValidation"
              place-holder="ruc"
              @input="updateProvider('ruc', $event)"
            />
            <register-field-validation
              :value="providerCompany.businessName"
              :disabled="disabled_user_info"
              field-name="Razón Social"
              :validation="businessValidation"
              place-holder="nombre entidad proveedora"
              @input="updateProvider('businessName', $event)"
            />
            <register-field-validation
              :value="providerCompany.address"
              :disabled="disabled_user_info"
              field-name="Dirección"
              :validation="addressValidation"
              place-holder="dirección entidad proveedora"
              @input="updateProvider('address', $event)"
            />
            <register-field-validation
              :value="providerCompany.phoneNumber"
              :disabled="disabled_user_info"
              field-name="Teléfono"
              :validation="phoneValidation"
              place-holder="teléfono entidad proveedora"
              @input="updateProvider('phoneNumber', $event)"
            />
          </v-container>
        </v-form>
      </v-card-subtitle>
      <v-card-actions class="d-flex justify-end">
        <v-btn v-show="!showButtons" color="primary" style="padding: 15px" rounded @click="showEditButtons">
          Editar
        </v-btn>
        <v-btn
          v-show="showButtons"
          depressed
          color="primary"
          style="padding: 15px"
          :disabled="disabled"
          rounded
          @click="save"
        >
          GUARDAR
        </v-btn>
        <v-btn
          v-show="showButtons"
          depressed
          color="primary"
          style="padding: 15px"
          rounded
          outlined
          @click="showEditButtons"
        >
          CANCELAR
        </v-btn>
      </v-card-actions>
    </v-card>

    <v-row justify="space-between">
      <v-col cols="12" md="auto">
        <p class="text-h5 primary-color page-title">
          Información del responsable
        </p>
      </v-col>
    </v-row>
    <v-card class="mx-auto responsible-card" max-width="100%">
      <v-card-subtitle class="pb-0">
        <v-form ref="form" lazy-validation>
          <v-container fluid>
            <register-field-validation :value="responsibleInfo.name" :disabled="disabled_user_info" field-name="Responsable" :validation="nameValidation" place-holder="nombre del responsable" />
            <register-field-validation :value="providerCompany.email" :disabled="disabled_user_info" field-name="Correo del responsable" :validation="emailValidation" place-holder="correo del responsable" />
          </v-container>
        </v-form>
      </v-card-subtitle>
      <v-card-actions class="d-flex justify-end">
        <v-btn color="primary" style="padding: 15px" rounded>
          Resetear Contraseña
        </v-btn>
      </v-card-actions>
    </v-card>
    <br>
    <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
      {{ snackBar.text }}
      <template #action="{ attrs }">
        <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
          <v-icon>mdi-window-close</v-icon>
        </v-btn>
      </template>
    </v-snackbar>
    <confirmation-modal :is-open="showModal" :modal-text="modalText" @confirm="confirmUpdate" @cancel="cancelUpdate" />
  </div>
</template>
<script>
import { mapActions, mapState } from 'vuex';
import { rucRules, companyNameRules, imageFileRules, phoneRules, addressRules, nameRules, emailRules } from '@/helpers/validation';
import RegisterFieldValidation from '~/components/InputField/RegisterFieldValidation';
import ImageField from '~/components/InputField/ImageField';
import ConfirmationModal from '~/components/register/confirmationModal';
export default {
  name: 'ModificarEntidadProveedora',
  components: {
    RegisterFieldValidation,
    ImageField,
    ConfirmationModal,
  },
  data: () => ({
    snackBar: {
      show: false,
      color: 'primary',
      text: '',
    },
    provider: {},
    responsibleInfo: {
      name: null,
      email: null,
    },
    rucValidation: rucRules,
    businessValidation: companyNameRules,
    imageValidation: imageFileRules,
    phoneValidation: phoneRules,
    addressValidation: addressRules,
    nameValidation: nameRules,
    emailValidation: emailRules,
    disabled_user_info: true,
    showModal: false,
    showButtons: false,
    disabled: false,
    modalText: '¿Está seguro que desea guardar los cambios?',
  }),
  computed: {
    ...mapState({
      providerCompany: state => state.providercompany.providercompany.providerCompany,
      loading: state => state.providercompany.providercompany.loading,
    }),
  },
  mounted() {
    this.getProviderCompanyStore();
  },
  methods: {
    ...mapActions({
      getProviderCompany: 'providercompany/providercompany/getProviderCompany',
      saveProviderCompany: 'providercompany/providercompany/saveProviderCompany',
    }),
    updateProvider(fieldName, updatedValue) {
      this.$store.dispatch('providercompany/providercompany/updateField', { providerCompany: this.providerCompany, fieldName, updatedValue });
    },
    async confirmUpdate() {
      await this.saveProviderCompany(this.providerCompany);
      this.showEditButtons();
      this.snackBar.text = 'Datos actualizados correctamente';
      this.snackBar.show = true;
    },
    getProviderCompanyStore() {
      this.getProviderCompany();
    },
    cancelUpdate() {
      this.openModal = false;
      this.showModal = false;
    },
    showEditButtons() {
      this.showButtons = !this.showButtons;
      this.disabled_user_info = !this.disabled_user_info;
    },
    save() {
      this.showModal = true;
    },
  },
};
</script>
<style scoped>
.primary-color{
  color: #535B6C
}
.page-title {
  margin-top: 2rem;
  margin-left: 1rem;
}
.responsible-card {
  margin-bottom: 1rem;
  padding-bottom: 1rem;
  padding-right: 1rem;
}
.provider-company-card {
  padding-bottom: 1rem;
  padding-right: 1rem;
}
</style>
